﻿using System.Web;
using System.Web.Compilation;
using System.Web.Routing;
using System.Web.UI;

public class CustomRouteHandler : IRouteHandler
{
    public string VirtualPath
    {
        get;
        private set;
    }

    public CustomRouteHandler(string virtualPath)
    {
        this.VirtualPath = virtualPath;
    }

    #region IRouteHandler Members

    public IHttpHandler GetHttpHandler(RequestContext requestContext)
    {
        foreach (var urlParm in requestContext.RouteData.Values)
        {
            requestContext.HttpContext.Items[urlParm.Key] = urlParm.Value;
        }

        var page = BuildManager.CreateInstanceFromVirtualPath(VirtualPath, typeof(Page)) as IHttpHandler;
        return page;
    }

    #endregion
}